[LeetCode 278] First Bad Version(二分查找的一个常见注意点)

来源:互联网 发布:大数据与电子商务 编辑:程序博客网 时间:2024/06/02 03:08

题目内容

278.First Bad Version
You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.
Suppose you have n versions [1, 2, …, n] and you want to find out the first bad one, which causes all the following ones to be bad.
You are given an API bool isBadVersion(version) which will return whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API.
Credits:
Special thanks to @jianchao.li.fighter for adding this problem and creating all test cases.
问题来源

问题简述

查找第一个坏的版本,每一个坏的版本后面的版本都是坏的。

题目分析

由于线性查找会超时,只有使用二分查找。注意二分查找中中间数一般记为low+(high-low)/2,否则可能使加法溢出。其次在本题中要注意根据问题叙述严格定界,减少不必要的讨论。

代码示例

bool isBadVersion(int version);class Solution {public:    int firstBadVersion(int n) {        bool flag=false;        if(isBadVersion(1)==true)            return 1;        int high=n;        int low=1;        int mid;        while(low<high)        {            mid=low+(high-low)/2;            if(isBadVersion(mid)==false)            low=mid+1;            else             high=mid;        }         return low;    }};

时间复杂度(logn)

0 0
原创粉丝点击